function write(id, data) {
  document.getElementById(id).innerText = `fetch:\n${data.fetchResponse}\nXHR:\n${data.xhrResponse}\n`;
}

function request() {
  return fetch('https://httpbin.org/cookies', { credentials: "include" })
    .then(response => response.json())
    .then((fetchResponse) => {
      return new Promise((r) => {
        let x = new XMLHttpRequest();
		x.withCredentials = true;
        x.open("GET", 'https://httpbin.org/cookies');
        x.onreadystatechange = () => {
          if (x.readyState === 4 && x.status === 200) {
            r({ fetchResponse:JSON.stringify(fetchResponse), xhrResponse: JSON.stringify(JSON.parse(x.response)) });
          }
        }
		x.send();
      });

    });
}


window.addEventListener("load", () => {
  chrome.runtime.onMessage.addListener((r, s) => {
    if (r.name === 'response') {
      write(r.id, r.data);
    }
  });
  chrome.tabs.query({ active: true, currentWindow: true }, (tabs) => {
    if (tabs && tabs.length > 0 && tabs[0].url && tabs[0].url.startsWith('https://httpbin.org')) {
      chrome.tabs.sendMessage(tabs[0].id, { name: 'request' });
      chrome.runtime.sendMessage({ name: 'request' });
      request().then((pData) => write('dataPopup', pData));
    } else {
      document.getElementById('dataFront').innerText = 'taking you to httpbin... reopen popup when there.'
      chrome.tabs.create({ url: 'https://httpbin.org', active: true });
    }
  });
});
